{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: MOKRA ROBOTA                                   *}
{*   Plik:                INOUT.PAS - modul InOut                        *}
{*   Autor:               Marcin Engel                                   *}
{*************************************************************************}

unit InOut;

{--------------------------------------------------------}
{        Modul Wejscie-Wyjscie dla zadania               }
{                  Mokra Robota                          }
{                                                        }
{  Autor: Marcin Engel        Data ost. mod.: 20.07.1996 }
{--------------------------------------------------------}

interface

 uses Typy;

{--------------------------------------------------------}
{                  Specyfikacja wejscia:                 }
{                                                        }
{ W pierwszym wierszu pliku MOK.IN znajduje sie jedna    }
{ liczba calkowita n z zakresu [1..4] - liczba naczyn.   }
{                                                        }
{ W drugim wierszu pliku MOK.IN znajduje sie n liczb     }
{ naturalnych z zakresu [1..49].                         }
{ Sa to pojemnosci poszczegolnych naczyn.                }
{                                                        }
{ W trzecim wierszu pliku MOK.IN znajduje sie n liczb    }
{ naturalnych z zakresu [0..49].                         }
{ Sa to zadane pojemnosci koncowe poszczegolnych naczyn  }
{--------------------------------------------------------}

 procedure CzytajDane(var Ile:NumerNaczynia; var sp,sk:Stan);
  { Procedura wczytuje liczbe naczyn, stan poczatkowy i
    koncowy z pliku wejsciowego                          }

{--------------------------------------------------------}
{                  Specyfikacja wyjscia:                 }
{                                                        }
{ W pierwszym wierszu pliku MOK.OUT znajduje sie jedna   }
{ liczba calkowita lub jedno slowo NIE.                  }
{ Jest to liczba krokow prowadzaca do sytuacji koncowej  }
{ lub informacja o nieistnieniu przejscia z sytuacji     }
{ poczatkowej do koncowej.                               }
{--------------------------------------------------------}

 procedure WypiszWynik(Krok:Kroki);
  {Jesli Kroki >= 0, to procedura wypisuje wartosc
   zmiennej Krok do pliku wyjsciowego. Wpp. do pliku
   wyjsciowego zapisywane jest slowo NIE.                }

implementation

 const
  PlikWe='MOK.IN';        { Nazwa pliku wejsciowego }
  PlikWy='MOK.OUT';        { Nazwa pliku wyjsciowego }

 procedure CzytajDane(var Ile:NumerNaczynia; var sp,sk:Stan);
  var
   i:NumerNaczynia;
   f:text;
   x:Pojemnosc;
 begin
  assign(f,PlikWe);
  reset(f);
  readln(f,Ile);          { ile naczyn }
  for i:=1 to Ile do begin
   read(f,x);            { pojemnosci, a zarazem stan poczatkowy }
   Nalej(sp,i,x)
  end;
  readln(f);
  for i:=1 to Ile do begin
   read(f,x);        { zadany stan koncowy }
   Nalej(sk,i,x)
  end;
  close(f)
 end; {CzytajDane}

 procedure WypiszWynik(Krok:Kroki);
  var f:text;
 begin
  assign(f,PlikWy);
  rewrite(f);
  if Krok>=0 then
   writeln(f,Krok)
  else
   writeln(f,'NIE');
  close(f)
 end; {WypiszWynik}

end. {unit InOut}
