{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: MOKRA ROBOTA                                   *}
{*   Plik:                TYPY.PAS - modul Typy                          *}
{*   Autor:               Marcin Engel i Piotr Chrzastowski-Wachtel      *}
{*************************************************************************}

unit Typy;

{--------------------------------------------------------}
{    Modul definiujacy typy abstrakcyjne dla zadania     }
{                  Mokra Robota                          }
{                                                        }
{  Autor: M. Engel            Data ost. mod.: 29.11.1995 }
{         P. Chrzastowski-Wachtel              20.07.96  }
{--------------------------------------------------------}

interface

 const
  MaxPoj     =49;      { maksymalna pojemnosc naczynia }
  MaxNaczynie=4;       { maksymalna liczba naczyn   }
  MaxWaga    =MaxPoj*MaxNaczynie;
 type
  NumerNaczynia=1..MaxNaczynie;
  Pojemnosc    =0..MaxPoj;
  Waga         =0..MaxWaga;
  Stan         =array [NumerNaczynia] of Pojemnosc;
  Kroki        =LongInt;

 procedure Nalej(var s:Stan; i:NumerNaczynia; p:Pojemnosc);
  { Wlewa do i-tego naczynia w zestawie s, p litrow wody }
  { Po wykonaniu: s[i] = p }

 function Zawartosc(s:Stan; i:NumerNaczynia):Pojemnosc;
  { Zwraca zawartosc i-tego naczynia w zestawie s }

 function Puste(s:Stan; i:NumerNaczynia):boolean;

 function Pelne(s,sp:Stan; j:NumerNaczynia):Boolean;

 function Porownaj(Ile:NumerNaczynia; s1,s2:Stan):integer;

 function Rowne(Ile:NumerNaczynia; s1,s2:Stan):boolean;

 function LacznaPoj(Ile:NumerNaczynia; s:Stan):Waga;

 procedure Wylej(s:Stan; i:NumerNaczynia; var ns:Stan);

 procedure Przelej(s,sp:Stan; i,j:NumerNaczynia; var ns:Stan);

implementation

 procedure Nalej(var s:Stan; i:NumerNaczynia; p:Pojemnosc);
 begin
  s[i]:=p
 end; {Nalej}

 function Zawartosc(s:Stan; i:NumerNaczynia):Pojemnosc;
 begin
  Zawartosc:=s[i]
 end; {Zawartosc}

 function Puste(s:Stan; i:NumerNaczynia):boolean;
 begin
  Puste:=s[i]=0
 end; {Puste}

 function Pelne(s,sp:Stan; j:NumerNaczynia):Boolean;
 begin
  Pelne:=s[j]=sp[j]
 end; {Pelne}

 function Porownaj(Ile:NumerNaczynia; s1,s2:Stan):Integer;
   {Funkcja przyjmuje wartosc:
     0, jesli oba stany s1,s2 sa rowne,
    -1, jesli pierwsze rozniace naczynie ma mniej wody w s1
     1, jesli pierwsze rozniace naczynie ma mniej wody w s2}
  var
   k      :1..MaxNaczynie+1;
   Jeszcze:boolean;
 begin
  k:=1;
  repeat
   Jeszcze:=Zawartosc(s1,k)=Zawartosc(s2,k);
   k:=k+1
  until not Jeszcze or (k>Ile);
  if Jeszcze then Porownaj:=0
  else if Zawartosc (s1,k-1)<Zawartosc(s2,k-1) then
   Porownaj:=-1
  else Porownaj := 1
 end; {Porownaj}

 function Rowne(Ile:NumerNaczynia; s1,s2:Stan):boolean;
 begin
  Rowne:=Porownaj(Ile,s1,s2)=0
 end; {Rowne}

 function LacznaPoj(Ile:NumerNaczynia; s:Stan):Waga;
  var
   Suma:Waga;
   i   :NumerNaczynia;
 begin
  Suma:=s[1];
  for i:=2 to Ile do
   Suma:=Suma+s[i];
  LacznaPoj:=Suma
 end; {LacznaPoj}

 procedure Wylej(s:Stan; i:NumerNaczynia; var ns:Stan);
 begin
  ns:=s;
  ns[i]:=0
 end; {Wylej}

 procedure Przelej(s,sp:Stan; i,j:NumerNaczynia; var ns:Stan);
  var Suma:Waga;
 begin
  ns:=s;
  Suma:=s[j]+s[i];
  if Suma<=sp[j] then begin
   ns[i]:=0;
   ns[j]:=Suma
  end
  else begin
   ns[j]:=sp[j];
   ns[i]:=Suma-sp[j]
  end
 end; {Przelej}

end. {unit Typy}
